module tb ();
    reg a,b,c;
    wire s,carry;
    problem2_2 pb4 (
        .a(a),
        .b(b),
        .c(c),
        .s(s),
        .carry(carry)
    );
    // Initialization
    initial 
    begin
        $display("----------------------");
        $display("-- Simulation Start --");
        $display("----------------------");
    end
    //READ file
    integer fd;
    initial
    begin
        fd = $fopen("golden.data","r");
    end
    integer i;
    integer fail;
    integer count;
    reg gc,gs;
    initial  
    begin
        count = 0;
        fail = 0;
        for (i = 0; i < 8; i = i + 1) begin
            a = i[0];
            b = i[1];
            c = i[2];
            $fscanf(fd,"%d %d",gc,gs);
            count = count + 1; 
            #10;
            if((gc !== carry) || (gs !== s))begin
                fail = fail + 1;
                $display("Case %d :\n\tInput a,b,c : %d,%d,%d\n\tExpect c,s : %d,%d\n\tOutput c,s : %d,%d\n",count,a,b,c,gc,gs,carry,s);
            end
        end
        if (fail === 0)
        begin
            $display("\n");
            $display("\n");
            $display("        ****************************    _._     _,-'\"\"`-._        ");
            $display("        **  Congratulations !!    **   (,-.`._,'(       |\\`-/|     ");
            $display("        **  Simulation1 PASS!!    **       `-.-' \\ )-`( , o o)     ");
            $display("        ****************************             `-    \\`_`\"'-    ");
            $display("\n");
        end
        else
        begin
            $display("\n");
            $display("\n");
            $display("        ****************************         |\\      _,,,---,,_     ");
            $display("        **  OOPS!!                **   ZZZzz /,`.-'`'    -.  ;-;;,_  ");
            $display("        **  Simulation1 Failed!!  **        |,4-  ) )-,_. ,\\ (  `'-'");
            $display("        ****************************       '---''(_/--'  `-'\\_)     ");
            $display("         Totally has %d errors                     ", fail); 
            $display("\n");
        end
        $fclose(fd);
        $finish;
    end 
endmodule